/*
 * file:        Encoder.C
 * purpose:     class definition for turning encoders (works together with system tick interrupt)
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2003-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#include "Encoder.h"

#ifdef HAVE_ENCODER
using namespace srd;

void Encoder::handle1Increment() {
  int8_t i=0, delta=0;

  // check encoder turns
  if (right.isHigh()) i  = 1;
  if (left.isHigh())  i ^= 3;
  delta = encLast - i;

  if (delta & 1) {
     encLast = i;
     encDelta += (delta & 2) - 1;
     }
  handler->handleCounter(encDelta);
  encDelta = 0;
  }


void Encoder::handle2Increment() {
  int8_t i=0, delta=0;

  // check encoder turns
  if (right.isHigh()) i  = 1;
  if (left.isHigh())  i ^= 3;
  delta = encLast - i;

  if (delta & 1) {
     encLast = i;
     encDelta += (delta & 2) - 1;
     }
  i = encDelta;
  encDelta = i & 1;
  handler->handleCounter(i >> 1);
  }


void Encoder::handle4Increment() {
  int8_t i=0, delta=0;

  // check encoder turns
  if (right.isHigh()) i  = 1;
  if (left.isHigh())  i ^= 3;
  delta = encLast - i;

  if (delta & 1) {
     encLast = i;
     encDelta += (delta & 2) - 1;
     }
  i = encDelta;
  encDelta = i & 3;
  handler->handleCounter(i >> 2);
  }

#endif
