/*
 * file:        SystemTick.h
 * purpose:     applications time base
 * project:     c++ framework for avr controllers
 * author:      Reinhard Mantey
 * copyright:   2003-2016 (c) Creative commons - by-nc-sa - some rights reserved
 *              see http://creativecommons.org/licenses/by-nc-sa/3.0/ for details
 */
#ifndef SYSTEMTICK_H
#define SYSTEMTICK_H
#include "halConfig.h"
#include "HWTimer.h"

#ifdef HAVE_SYSTEMTICK
namespace srd {


class SystemTick
{
  static uint32_t seconds;
  static int16_t ticks;
  static int16_t maxTicks;
  static void run() __asm__(STR(TIMER1_OVERFLOW_ITR)) __attribute__((__signal__, __used__, __externally_visible__));

public:
  SystemTick(int16_t ips = 1000U)
   : timer(TimerMode::CTC_ICR, PreScale::PS_1, false) {
    timer.setICRValue(F_CPU / ips);
    timer.enableOverflowInterrupt(true);
    maxTicks = ips;
    };

  static uint32_t getSeconds()  { return seconds; };
  static int16_t  getTicks()    { return ticks;   };

  const Timer1& getTimer()      { return timer;   };

private:
  Timer1 timer;
  };

}
#endif                                                     // HAVE_SYSTEMTICK
#endif
